\documentclass[11pt, a4paper]{article}


\usepackage{url}
% DOCUMENT LAYOUT
\usepackage[margin=1in]{geometry}
\parindent=15pt

% Reduce spacing in enumerate, enumerate and titles
\usepackage{multicol}
\usepackage{enumitem}
\setenumerate{nolistsep}
\setenumerate{nolistsep}
% \setlength{\parskip}{1em}

% FONTS
\usepackage[utf8]{inputenc}

% HEADINGS and TITLES
\usepackage{sectsty}
\usepackage[normalem]{ulem}

% packages
\usepackage{amsmath, amsfonts, latexsym, listings, cite, amssymb,
  amsthm, stmaryrd, scrextend, float, mathtools}

\usepackage{graphicx}
\graphicspath{ {./img/} }

% Not native to tex
\usepackage{bussproofs}
\usepackage{qtree}
\usepackage{tikz-cd}

\usepackage{titling}
\setlength{\droptitle}{-90pt}
\title{CS5350: Homework 2}
\author{Alex Hubers, Jamil Gafur, Xiang Liu}

% Thm styling if I need it
\theoremstyle{definition}
\newtheorem{definition}{Definition}[section]
\newtheorem{theorem}{Theorem}[section]
\newtheorem{corollary}{Corollary}[theorem]
\newtheorem{lemma}[theorem]{Lemma}
\newtheorem*{remark}{Remark}

% pretty references
\usepackage{prettyref}
\newcommand{\pref}[1]{\prettyref{#1}}
\newrefformat{assn}{Assumption~\ref{#1}}
\newrefformat{prop}{Property~\ref{#1}}
\newrefformat{fig}{Figure~\ref{#1}}
\newrefformat{sec}{Section~\ref{#1}}
\newrefformat{thm}{Theorem~\ref{#1}}
\newrefformat{lem}{Lemma~\ref{#1}}
\newcommand\secref[1]{\pref{sec:#1}}
\newcommand\figref[1]{\pref{fig:#1}}
\newcommand\appref[1]{\pref{app:#1}}

\bibliographystyle{acm}

\usepackage{listings}
\lstloadlanguages{Haskell}
% \usepackage{libertine}
\usepackage{lmodern}
\lstset{
  showstringspaces=false,
  language=Haskell,
  xleftmargin=\parindent,
  basicstyle=\ttfamily,
  % keepspaces=false,
  morecomment=[l]{--},
  mathescape=true,
  numberstyle=\tiny,
  flexiblecolumns=false,
  basewidth={0.5em,0.45em},
  morekeywords={instance, Theorem, Lemma, class, where, if, data, then, else, type, case, of, require, newtype},
  keywordstyle={\bfseries},%\underbar,
}
\lstnewenvironment{code}{}{}
%\lstMakeShortInline{|}
\lstnewenvironment{codef}{\lstset{basicstyle=\ttfamily\small,xleftmargin=1.5em}}{}

% My Commands
\newcommand{\SetOf}[1]{\ensuremath{\{#1\}}}
\newcommand{\banana}[1]{\ensuremath{\llparenthesis\, #1\, \rrparenthesis}}

\newcommand{\Start}{\ensuremath{\vartriangleright}}
\newcommand{\Halt}{\ensuremath{\square}}

\newcommand{\qstate}[1]{\ensuremath{q_{#1}}}
\newcommand{\qcheck}[1]{\qstate{check_{#1}}}

\newcommand{\qstart}{\qstate{start}}
\newcommand{\qhalt}{\qstate{halt}}
\newcommand{\qscan}{\qstate{scan}}

\newcommand{\LA}{\ensuremath{\langle}}
\newcommand{\RA}{\ensuremath{\rangle}}
\newcommand{\binset}{\ensuremath{\lbrace 0, 1 \rbrace}}

% BEGIN DOCUMENT
\begin{document}
\maketitle


\section*{Exercise 1}
Suppose you are given a set of $n$ wireless devices, with positions
$p_{i} = (x_i,y_i)$ for $i = 1, 2, ...,n$. The devices are cheap and the enviorment
which they are placed in is hostile and so the devices are prone to failure. As
a result, for each device $v$ we want to find and assign $k \geq 1$ other
``backup'' devices that are within distance $d$ meters of $v$. (One of the
``backup'' devices will do the work for $v$ in case $u$ fails. Also fails and
its ``backup'' devices also start failing.) The one problem with this idea is
that it is possible for a device to get overloaded if it serves as a “backup”
for too many other devices. So for some positive integer parameter $b$, we want
to ensure that no device serves as a ``backup'' for more than $b$ other devices.

Here is the problem. Given $p_i$, $1 \leq i \leq n$ and $d, k,$ and $b$,
describe a polynomial-time algorithm that determines if it is possible to assign
“backup” device sets for all of the n devices. If this is indeed possible, your
algorithm should return an assignment of “backup” device sets for each device.

\subsection*{Solution}
\begin{center}
\begin{tikzpicture}[thick,main/.style={draw, circle}]
	\node[main] (1) [minimum size=8.5mm]{$s$};
	\node[main] (2) [right of=1,node distance=30mm,minimum size=8.5mm] {$p_3$};
	\node[main] (3) [above of=2,node distance=15mm,minimum size=8.5mm] {$p_2$};
	\node[main] (4) [above of=3,node distance=15mm,minimum size=8.5mm] {$p_1$};
	\node[main] (5) [below of=2,node distance=30mm,minimum size=8.5mm]
	{$p_n$};
	\path (2) -- (5) node [font=\Huge, midway, sloped] {$\dots$};
	\draw[->] (1) -- node[above] {$k$} (2);
	\draw[->] (1) -- node[above] {$k$} (3);
	\draw[->] (1) -- node[above] {$k$} (4);
	\draw[->] (1) -- node[above] {$k$} (5);
	\node[main] (6) [right of=2,node distance=30mm] {$p_3'$};
	\node[main] (7) [above of=6,node distance=15mm] {$p_2'$};
	\node[main] (8) [above of=7,node distance=15mm] {$p_1'$};
	\node[main] (9) [below of=6,node distance=30mm]
	{$p_n'$};
	\path (6) -- (9) node [font=\Huge, midway, sloped] {$\dots$};
	\draw[->] (4) -- node[right] {$1$} (6);
	\draw[->] (3) -- node[right] {$1$} (9);
	\draw[->] (2) -- node[left] {$1$} (8);
	\draw[->] (2) -- node[right] {$1$} (9);
	\draw[->] (5) -- node[left] {$1$} (6);
	\draw[->] (5) -- node[left] {$1$} (7);
	\node[main] (10) [right of=6,node distance=30mm,minimum size=8.5mm]	{$t$};
	\draw[->] (6) -- node[above] {$b$} (10);
	\draw[->] (7) -- node[above] {$b$} (10);
	\draw[->] (8) -- node[above] {$b$} (10);
	\draw[->] (9) -- node[above] {$b$} (10);
      \end{tikzpicture}
\end{center}

We identify in the problem the following constraints:

\begin{itemize}
\itemsep0em 
\item Each device $v$ must have at least $k \geq 1$ backup devices.
\item No device should be assigned as backup to more than $b$ other devices.
\end{itemize}

We encode these constraints as a flow network (see above). The left column
$p_{1}, ..., p_{n}$ represents the working devices, and the right column
$p_{1}', ..., p_{n}'$ represents the backup devices. Each edge $s \to p_{i}$
encodes the constraint that $p_{i}$ can have $k$ backups; a saturated edge at
$s \to p_{i}$ signifies that $p_{i}$ has $k$ backups. An edge $p_i \to p_j'$ has weight 1,
and signifies that the distance $(p_i, p_j') \leq d$ and $p_j'$ is therefore
eligible as a backup for $p_i$. So a saturated edge $p_{i} \to p_{j}'$ signifies that
phone $p_{i}$ is backed up by $p_{j}'$. Note that there is no edge
$p_i \to p_i'$ because a device cannot be backed up by itself.


\paragraph{The algorithm.}
Run any (polynomial time) MaxFlow algorithm on this network. If every edge
outbound from $s$ is saturated in a maximal flow, we claim there is an assignment
such that 1) every device has $k$ backups, and 2) every device backs-up at most
$b$ other devices. If every edge outbound from $s$ cannot be saturated, we claim no
possible assignment is available.

\paragraph{Polynomial running time.}
MaxFlow is polynomial, so the only burden is to show that extraction of a solution
is polynomial. But this is trivial, as we merely need to look at the subset of
edges incident on $s$.

\paragraph{Proof of correctness $(\Rightarrow)$.}
Let $f^*$ be a maxflow that saturates all edges outbound from $s$. $f^*$ is
integral since all the capacities are integral. Since
$c(p_i \rightarrow p_j') = 1$, $f^*(p_i \rightarrow p_j') \in \{0, 1\}$ for
every edge $p_i \to p_j'$. We can interpret $f^*(p_i \rightarrow p_j')$ as
indication of whether $p_j$ is a backup for $p_i$.

\begin{itemize}
\itemsep0em 
\item Consider an arbitrary $p_i$. Flow conservation at $p_i$ implies that
  $f^*(s \rightarrow p_i)$ is the number of backups that $p_i$ has. Since
  $s \to p_i$ is saturated by $f^*$, the number of backups for $p_i$ is exactly
  $k$.
	
\item Consider an arbitrary $p_j'$. Flow conservation at $p_j'$ implies
  that $f^*(p_j' \rightarrow t)$ is the number of devices for which $p_j$ serves
  as backup, and the capacity constraint on edge $p_j' \to t$ implies
  that $p_j$ serves as a backup for at most $b$ devices.
\end{itemize}
\noindent

Thus, there exists a valid way of measuring all conditions.


\paragraph{Proof of correctness $(\Leftarrow)$.}
Suppose there is a valid way of assigning backups. Without loss of generality,
assume that for each device, there are exactly $k$ backups. Create a flow as
follows:

$$
f(p_i \to p_j')=
\begin{dcases}
	1, & \text{if $p_j$ is a backup for $p_i$ } \\
	0, & \text{otherwise}
\end{dcases}
$$

Then set $f(s \rightarrow p_i)$ and $f(p_j' \rightarrow t)$ for all $p_i$ and
$p_j'$ to satisfy flow conservation. Since we started with a valid way of
assigning backups, $f(p_j' \rightarrow t) \leq c(p_j' \rightarrow t) =
b$. Since each device has $k$ backups,
$f(s \rightarrow p_i) = c(s \rightarrow p_i) = k$. Thus, $f$ is a feasible flow.


\section*{Exercise 2}
Suppose we are given an array $A[1...m][1...n]$ of non-negative real number. We
want to round A to an integer matrix, by replacing each entry $x$ in A with
either $\lfloor x \rfloor$ or $\lceil x \rceil$, without changing the sum of entries in a row or column
of $A$.

For example
$$ \begin{bmatrix}
1.2 & 3.4 & 2.4 \\
3.9 & 4.0 & 2.1 \\
7.9 & 1.6 & .5
\end{bmatrix}  \to \begin{bmatrix}
1 & 4 & 2 \\
4 & 4 & 2 \\
8 & 1 & 1
\end{bmatrix} $$

\begin{itemize}
\itemsep0em 
\item (a) Describe and analyze an efficient algorithm that either rounds A in
  this fashion, or reports correctly that no such rounding is possible.
\item (b) Prove that a legal rounding is possible if and only if the sum of
  entries in each row is an integer, and the sum of entries in each column is an
  integer. In other words, prove that either your algorithm from part (a)
  returns a legal rounding, or a legal rounding is obviously impossible.
\end{itemize}

\subsection*{Solution (a)}
We will model this problem as a flow network with both a minimum and maximum
capacity function (as in problem 2, HW1). Let $R_{i}$ denote the $i$th row of
the matrix and $C_{j}$ denote the $j$th column. $\Sigma R_{i}$ and $\Sigma C_{j}$ are shorthand for
$\Sigma_{x \in R_{i}} x$ and $\Sigma_{x \in C_{j}} x$, respectively.

\begin{center}
\begin{tikzpicture}[thick,main/.style={draw, circle}]
  \node[main] (1) [minimum size=8.5mm]{$s$};
  
  \node[main] (2) [right of=1,node distance=30mm,minimum size=8.5mm] {$R_{3}$};
  \node[main] (3) [above of=2,node distance=15mm,minimum size=8.5mm] {$R_2$};
  \node[main] (4) [above of=3,node distance=15mm,minimum size=8.5mm] {$R_{1}$};
  \node[main] (5) [below of=2,node distance=30mm,minimum size=8.5mm] {$R_m$};
  \path (2) -- (5) node [font=\Huge, midway, sloped] {$\dots$};
  \draw[->] (1) -- node[below] {$\lfloor \Sigma R_{i} \rfloor, \lceil \Sigma R_{i} \rceil$} (2);
  \draw[->] (1) -- node[above] {} (3);
  \draw[->] (1) -- node[above] {} (4);
  \draw[->] (1) -- node[above] {} (5);
  \node[main] (6) [right of=2,node distance=30mm] {$C_{3}$};
  \node[main] (7) [above of=6,node distance=15mm] {$C_2$};
  \node[main] (8) [above of=7,node distance=15mm] {$C_1$};
  \node[main] (9) [below of=6,node distance=30mm] {$C_n$};
  \path (6) -- (9) node [font=\Huge, midway, sloped] {$\dots$};
  \draw[->] (4) -- node[right] {} (6);
  \draw[->] (4) -- node[right] {} (7);
  \draw[->] (4) -- node[above] {$\lfloor A_{ij} \rfloor, \lceil A_{ij} \rceil$} (8);
  \draw[->] (4) -- node[right] {} (9);
  \draw[->] (3) -- node[right] {} (6);
  \draw[->] (3) -- node[right] {} (7);
  \draw[->] (3) -- node[right] {} (8);
  \draw[->] (3) -- node[right] {} (9);
  \draw[->] (2) -- node[left] {} (6);
  \draw[->] (2) -- node[right] {} (7);
  \draw[->] (2) -- node[right] {} (8);
  \draw[->] (2) -- node[right] {} (9);
  \draw[->] (5) -- node[left] {} (6);
  \draw[->] (5) -- node[left] {} (7);
  \draw[->] (5) -- node[left] {} (8);
  \draw[->] (5) -- node[left] {} (9);
  \node[main] (10) [right of=6,node distance=30mm,minimum size=8.5mm]	{$t$};
  \draw[->] (6) -- node[above] {} (10);
  \draw[->] (7) -- node[above] {} (10);
  \draw[->] (8) -- node[right] {$\lfloor \Sigma C_{j} \rfloor, \lceil \Sigma C_{j} \rceil$} (10);
  \draw[->] (9) -- node[above] {} (10);
\end{tikzpicture}
\end{center}

Explicitly:
\begin{itemize}
\item Each edge $s \to R_{i}$ has flow bounded by the floor and ceiling (resp.) of
  the sum of that row. There is one such edge for each row.
\item Each row $R_{i}$ has an edge to each $C_{j}$ bounded by the floor and ceiling
  of the value at $A_{ij}$. 
\item Each column $C_{j}$ has an edge to $t$, bounded by the floor and ceiling
  of that column's sum.
\end{itemize}

We now claim that the matrix $A$ can be rounded iff (i) the sum of the entries
in each row and column is an integer, and (ii) this flow network has a max flow.
We will make use of the following theorem.

\paragraph{Integral-Flow Theorem.}
If each edge in a flow network has integral capacity and demand, then there
exists a maximum flow in which all flow values are integers.

\paragraph{Algorithm, running time.} Construct this network and execute any
polynomial-time max flow algorithm on it. Check if (i) holds. If it does, and
there exists a feasible flow for this network, return the rounded matrix (the
matrix values can be constructed from the flow, elaborated below). If not,
report that no such rounding is possible. The algorithm is polynomial: summing
rows and columns is $n^{2}m^{2}$ additions, and max flow is solved in polynomial
time.

\paragraph{Proof ($\Rightarrow$).} Suppose the hypotheses (i) and (ii) are
true. We will build a rounded matrix $A'$. By the integral-flow theorem, each
edge in the maximum flow should have integer flow value. So, populate $A'$ with
the flow values, i.e

$$
A'_{ij} = f(R_{i} \to C_{j})
$$

\noindent
Because the flow is feasible, we know that

$$
\lfloor A_{ij} \rfloor \leq A_{ij}' \leq \lceil A_{ij} \rceil
$$

\noindent
or, each element of $A'$ is the corresponding integer from $A$ appropriately
rounded.  Now we show that the sums of rows and columns are preserved. Observe
from (i) that

\begin{align*}
  &\lfloor \sum R_{i} \rfloor =  \lceil \sum R_{i} \rceil =  \sum R_{i} \\
  &\lfloor \sum C_{j} \rfloor =  \lceil \sum C_{j} \rceil =  \sum C_{j} \\
\end{align*}

\noindent
Now note that the flow into (and out of) each vertex $R_{i}$ must be precisely
$\sum R_{i}$. What flows out of $R_{i}$?  All the elements of that row. So by
flow conservation, we may conclude that

$$
\sum R_{i} = \sum_{1 \leq k \leq n}A_{ik} = \sum_{1 \leq k \leq n}A_{ik}'
$$

\noindent
or, each rounded row has its original sum. A similar argument follows for the
columns: due to flow conservation on each $C_{j}$, we have

$$
\sum C_{j} = \sum_{1 \leq k \leq m} A_{kj} = \sum_{1 \leq k \leq m} A_{kj}'
$$

\noindent
as desired.

\paragraph{Proof ($\Leftarrow$).} Now suppose that there exists a rounding $A'$
for matrix $A$. The rows and columns of $A'$ sum to integers, by assumption.
But these sums of $A'$ equal the sums of $A$ (by definition of a rounding), so
(i) holds: both sum to (the same) integers.

For (ii), we can deconstruct $A'$ into a feasible flow solution.

\begin{align*}
  &f(s \rightarrow R_i) = \sum R_{i}' \quad &\text{\emph{is either }} \lfloor \Sigma R_{i} \rfloor \text{\emph{ and }} \lceil \Sigma R_{i} \rceil. \\
  &f(R_i \rightarrow C_j) = A_{ij}'  \quad &\text{\emph{is either }} \lfloor A_{ij} \rfloor \text{\emph{ and }} \lceil  A_{jk} \rceil. \\
  &f(C_j \rightarrow t) = \sum C_{j}' \quad &\text{\emph{is either }} \lfloor \Sigma C_{j} \rfloor \text{\emph{ and }} \lceil \Sigma C_{j} \rceil.
\end{align*}

\noindent
As annotated, this satisfies the capacity constraints fairly trivially.  Flow
conservation is upheld by construction:

$$
f( s \rightarrow R_{i}) = \sum R_{i}' = \sum_{1 \leq k \leq n} A_{ik}
$$

\noindent
and for columns:

$$
f( C_{j} \rightarrow t) = \sum C_{j}' = \sum_{1 \leq k \leq m} A_{kj}
$$

\noindent
So there is a feasible solution to the flow network. By the integral-flow
theorem, either this flow is the maximum, or there exists a greater integral
flow.

%  \begin{enumerate}
%  \item Given Matrix A (defined in 2) we can construct a graph (defined in 3)
%    such that it has integer upper and lower bounds. We then can state that any
%    feasible integer flow can be a rounding solution for the problem.
%    \item \includegraphics[scale=0.3]{Hw2_p2_Matrix.png}
%    \item  \includegraphics[scale=0.3]{Hw2_p2_graph.png}
%  \end{enumerate}

\subsection*{Solution (b)}
For part b, we wish to show that (i) is sufficient:
if the rows and columns sum to integers, then $A$ can be rounded to $A'$.

\paragraph{Proof ($\Rightarrow$).} Suppose the rows and columns of $A$ sum to integers.
Construct a flow, again, by deconstructing $A$. We permit the flow values to be
fractional.

\begin{align*}
  &f(s \rightarrow R_i) = \sum R_{i} \quad &\text{\emph{bounded between }} \lfloor \Sigma R_{i} \rfloor \text{\emph{ and }} \lceil \Sigma R_{i} \rceil. \\
  &f(R_i \rightarrow C_j) = A_{ij}  \quad &\text{\emph{bounded between }} \lfloor A_{ij} \rfloor \text{\emph{ and }} \lceil  A_{jk} \rceil. \\
  &f(C_j \rightarrow t) = \sum C_{j} \quad &\text{\emph{bounded between }} \lfloor \Sigma C_{j} \rfloor \text{\emph{ and }} \lceil \Sigma C_{j} \rceil.
\end{align*}

\noindent
As annotated, this satisfies the capacity constraints fairly trivially.  Flow
conservation follows from an identical argument as before. So there is a
feasible solution to the flow network, and again, there exists a maximal
integral flow $f^{*}$. By part (a), $A$ can be rounded to $A'$. 


\paragraph{Proof ($\Leftarrow$).}
In the other direction, suppose there exists rounding $A'$ for matrix $A$.
The rows and columns of $A$ and $A'$ by assumption sum to the same values;
therefore both are integers.



% We know through basic discreat mathematics that the sum of any two real integer
% values would be another integer. If the sum of entries in each row is not an
% integer, when we do the integer rounding algorithm the flow would not exist as
% there is no optimal flow of two integers that produce a non integer value.

\section*{Exercise 3}
We can speed up the Edmonds-Karp “fattest path” algorithm, at least for
networks with small integer capacities, by relaxing our requirements for
the next augmenting path. Instead of finding the augmenting path with
maximum bottleneck capacity, we find a path whose bottleneck capacity is
at least half of maximum, using the following capacity scaling algorithm.
(This algorithm was actually proposed by Edmonds and Karp.)

Assume all the edge capacities are positive integers less than $U = 2^ k$ for
some integer $k$. The scaling algorithm maintains a bottleneck threshold
$\Delta$; initially, we set $U \leftarrow \Delta$. In each phase, the algorithm
augments along paths from $s$ to $t$ in which every edge has residual capacity
at least $\Delta$. When there is no such path, the phase ends, we set
$\Delta \leftarrow \lfloor \Delta / 2 \rfloor$, and the next phase begins. The algorithm ends
when $\Delta = 0$.

\begin{itemize}
\itemsep0em 
\item (a) How many phases will this algorithm execute in the worst case?
\item (b) Let $f$ be the flow at the end of the phase for a particular value
  $\Delta$. Prove that the capacity of a minimum cut in the residual graph
  $G_{f}$ is at most $|E| * \Delta$.
\item (c) Prove that in each phase of the scaling algorithm, there are at most
  $2*|E|$ augmentations.
\item (d) What is the overall running time of the capacity scaling algorithm?
\end{itemize}

\subsection*{Solution (a)}

Let $C$ be the maximum value of all capacities. According to the definition, we
pick some $k$ such that $\Delta = 2^{k}$ and $2^k \geq C$. WLOG, let $k$ and
$\Delta$ be the tightest such bound. It follows that
$k = \lceil \log_{2} C \rceil$. Now observe that the algorithm will run for
$k + 1$ phases; at each phase transition, we halve $\Delta$, so $\Delta$
transitions along the sequence $2^{k}, 2^{k - 1}, 2^{k - 2}, ..., 2^{1},
2^{0}$. Thus we incur $k + 1 = \lceil \log_{2} C \rceil + 1$ phases.

\subsection*{Solution (b)}
At the end of a phase for a particular value of $\Delta$, we have exhausted all paths
from $s$ to $t$ with bottleneck capacity $\geq \Delta$. According to the flow
decomposition theorem, the maxflow $f^*$ can be decomposed as $k$ feasible flows
$f_1, f_2, \dots, f_k$ on $k$ s-t paths $p_1, p_2, \dots, p_k$ such that i)
$k \leq |E|$, ii) the flow $f_{i}$ sends positive flow only on the edges of its
path $p_{i}$, and iii) $|f^*|=\sum_{i=1}^{k} |f_i|$. It follows from (ii) that
$|f_i| \leq \Delta$: we know there is no path that any $f_{i}$ can take which pushes
more than $\Delta$ units of flow. Since $k$ is bounded above by $|E|$ and
each $|f_{i}|$ is bounded above by $\Delta$, we know that $|f^*|=\sum_{i=1}^{k} |f_i| \leq |E| *\Delta$.
According to the Max-Flow Min-Cut Theorem, the minimum cut in the residual
graph $G_f$ is then at most $E * \Delta$.

\subsection*{Solution (c)}
The end of a phase for a particular value $\Delta$ is the start of a phase
for value $\Delta' = \Delta/2$ where $\Delta' > 0$. According to (b), The
maxflow $f^*$ in residual graph $G_f$,
$|f^*| \leq E * \Delta = 2 * E * \Delta'$. Since in each
augmentation, the augment path carries at least $\Delta'$ amount of flow,
there are at most $\frac{2 * E * \Delta'}{\Delta'} = 2 * E$
augmentations.

\subsection*{Solution (d)}
As per (a), the algorithm runs for $\lceil \log_{2} C \rceil + 1$ phases. As per (c), there are at
most $2*|E|$ augmentations per phase. Thus the running time is
$(\lceil \log_{2} C \rceil + 1) * (2E) = O(E\log C)$.

\section*{Exercise 4}
Consider the directed graph G given below with source s and target t identified.

\begin{center}
\includegraphics[scale=0.8]{hw2_3img.png}
\end{center}

\begin{itemize}
\itemsep0em 
\item (a) For this graph, write down the \emph{dual} of the maxflow LP.
\item (b) Describe a feasible solution to this LP with $\gamma_{e} \in \{0, 1/3\}$ for each edge $e \in E$.
  What is the cost of your solution? Is your solution optimal? How do you know?
\item (c) Describe a solution to this LP that is (i) optimal and (ii) assigns a fractional value
  to at least one variable $\gamma_{e}$  \emph{or} argue that such a solution is not possible.
\end{itemize}

\subsection*{Solution (a)}
Add an edge $t \to s$ with infinite capacity, and assign each vertex $v$ a
variable $\mu_{v}$ and each edge $u \to v$ a variable $\gamma_{uv}$, excluding
$t \to s$. Then the dual LP is to minimize
$$
16\gamma_{sa} + 13\gamma_{sc} + 10\gamma_{ac} + 4\gamma_{ca} + 12\gamma_{ab} +
9\gamma_{bc} + 14\gamma_{cd} + 7\gamma_{db} + 20\gamma_{bt} + 4\gamma_{dt}
$$

\noindent
subject to the constraints

\begin{align*}
  &\mu_{s} - \mu_{t} &\geq 1 \\
&\gamma_{sa} - \mu_{s} + \mu_{a} &\geq 0 \\
&\gamma_{sc} - \mu_{s} + \mu_{c} &\geq 0 \\
&\gamma_{ac} - \mu_{a} + \mu_{c} &\geq 0 \\
&\gamma_{ca} - \mu_{c} + \mu_{a} &\geq 0 \\
&\gamma_{ab} - \mu_{a} + \mu_{b} &\geq 0 \\
&\gamma_{bc} - \mu_{b} + \mu_{c} &\geq 0 \\
&\gamma_{cd} - \mu_{c} + \mu_{d} &\geq 0 \\
&\gamma_{db} - \mu_{d} + \mu_{b} &\geq 0 \\
&\gamma_{bt} - \mu_{b} + \mu_{t} &\geq 0 \\
&\gamma_{dt} - \mu_{d} + \mu_{t} &\geq 0 \\  
\end{align*}

\noindent
as well as the non-negativity constraints (universally quantified to save paper and eye-strain):
\begin{align*}
&\gamma_{uv} \geq 0 \quad &\forall u \to v \in (E - (t \to s))\; \\
&\mu_{v} \geq 0 \quad &\forall v \in V\ \\
\end{align*}

\subsection*{Solution (b)}
\begin{center}
\includegraphics[scale=0.25]{hw2_p4b.png}
\end{center}

All $\gamma$'s are $1/3$ except for $\gamma_{ac}, \gamma_{ca}, \gamma_{db},$ and
$\gamma_{bc}$, which are 0, so the cost is:
$$
1/3 * (16 + 13 + 12 +
14 + 20 + 4) = 26 \frac{1}{3}
$$

This is not optimal. Here is a better one: Set $\mu_{s} = 1$, $\mu_{t} = 0$,
$\gamma_{bt} = \gamma_{dt} = 1$, and all other edges 0 (meaning all $\mu$ values
are 1 except for $\mu_{t}$).  In other words, this is the cut with edges
$b \to t$ and $d \to t$ selected. This has weight 24.

\subsection*{Solution (c)}
The maximum flow of this network is 23, which corresponds to the cut along edges
$a \to b$, $d \to b$, and $d \to t$. So there exists a solution with all
$\gamma$ integral (specifically, the edges cut are 1 and the edges excluded are
0). The question is: does there exist an assignment to $\gamma$ with objective
value 23 but with one or more fractional $\gamma$? There is certainly a linear combination
of these $\gamma$ with fractional values that sums to 23 -- consider the following:

$$
12*\gamma_{ab} + 7*\gamma_{db} + 4*\gamma_{dt} = 12*\frac{14}{12} + 7*1 + 4*\frac{1}{2} =
14 + 7 + 2 = 23
$$

\noindent
However we can't find a way to make the $\mu$'s work using this approach. So our
answer is: it is probably not possible, but we're not sure why.

\section*{Exercise 5}
\textbf{(Weighted MVC)} In class we used the primal and dual LP relaxations of
MVC to obtain a 2-approximation. In this problem you will use a more complicated variant
of this approach to find a 2-approximation for \emph{weighted minimum vertex cover (WMVC)}. The
input to WMVC is a graph $G = (V, E)$ in which each vertex $v \in V$ has a weight $w(v) \in R^{+}$.
The goal is to find a vertex cover $S \subseteq V$ of minimum total weight.

\begin{itemize}
\itemsep0em 
\item (a) Write down the LP relaxation $L_{wmvc}$ of WMVC and the dual LP $D_{wmvc}$ of $L_{wmvc}$.
\item (b) Consider the following algorithm to find a solution to WMVC (see
  assignment reference).  Execute this algorithm on a graph $G = (V, E)$ where
  $V = \{A, B, C, D, E\}$, $E = \{\{A, E\}, \{B, E\}, \{C, E\}, \{D, E\}\}$, and vertex weights are
  $w(A) = 20$, $w(B) = 10$, $w(C) = 5$, $w(D) = 70$, $w(E) = 100$. Describe an execution
  in which the algorithm picks vertices $A, B, D,$ and $E$. Your description should specify
  which unfrozen variable was picked in each iteration, which value was increased, and which vertex
  (or vertices) was added to $S$ during the iteration.
\item (c) If we increase the weight of $B$ to 20, will the algorithm still be able to pick
  vertices $A, B, D,$ and $E$? Justify your answer.
\item (d) Prove that the algorithm produces a vertex cover $S \subseteq V$ such that $\sum_{v \in S}\; w(v) \leq 2 * \text{OPT}$
  where OPT is the weight of an optimal vertex cover. In other words, you are being asked to prove
  that the above algorithm yields a 2-approximation to WMVC.
\end{itemize}

\subsection*{Solution (a)}
Let each vertex $v$ be assigned primal variable $x_{v}$, and each edge $e$ be
assigned dual variable $y_{e}$. For notational convenience, denote the set of edges incident
on a vertex $v$ as $inc(v)$. Then $L_{wmvc}$ is given as:

\begin{align*}
  &\text{min}\; \sum_{v \in V}\; w(v) * x_{v}, \; \text{s.t.}\\
  &x_{u} + x_{v} \geq 1 &\forall\; (u - v) \in E \\
  & x_{v} \geq 0    &\forall\; v \in V
\end{align*}

\noindent
and $D_{wmvc}$ is given as:

\begin{align*}
  &\text{max}\; \sum_{e \in E}\; y_{e}, \; \text{s.t.} \\
  & \sum_{e\, \in\, inc(v)}\; y_{e} \leq w(v) &\forall\; v \in V \\ 
  & y_{e} \geq 0    &\forall\; e \in E
\end{align*}

\subsection*{Solution (b)}
\begin{center}
\begin{tikzpicture}[thick,main/.style={draw, circle}]
	\node[main] (1) [minimum size=8.5mm]{$E\; (100)$};
	\node[main] (2) [right of=1,node distance=30mm,minimum size=8.5mm] {$A\; (20)$};
	\node[main] (3) [above of=2,node distance=15mm,minimum size=8.5mm] {$B\; (10)$};
	\node[main] (4) [above of=3,node distance=15mm,minimum size=8.5mm] {$C\; (5)$};
	\node[main] (5) [above of=4,node distance=15mm,minimum size=8.5mm] {$D\; (70)$};
	\draw[-] (1) -- (2);
	\draw[-] (1) -- (3);
	\draw[-] (1) -- (4);
	\draw[-] (1) -- (5);

      \end{tikzpicture}
\end{center}

\begin{itemize}
\itemsep0em
\item Step 1: pick $y_{AE}$ and set $y_{AE} = 20$ such that the constraint on
  $A$ is tight. Add $A$ to $S$ and freeze $y_{AE}$.
\item Step 2: pick $y_{BE}$ and set $y_{BE} = 10$ such that the constraint on
  $B$ is tight. Add $B$ to $S$ and freeze $y_{BE}$.
		
\item Step 3: pick $y_{DE}$ and set $y_{DE} = 70$ such that the constraint on
  $D$ is tight. Add $D$ to $S$ and freeze $y_{DE}$. Also, the constraint on $E$
  is tight. Add $E$ to $S$ and freeze $y_{CE}$.	
\item Step 4: all edges are frozen, algorithm halts.
\end{itemize}


\subsection*{Solution (c)}
The algorithm is now unable to pick vertices $A, B, D$ and $E$. Picking
each of these vertices means $\sum_{e\, \in inc(E)}\; y_{e} = 110$, violating the
constraint on $E$.

\subsection*{Solution (d)}

\paragraph{$S$ is a vertex cover.}
Towards a contradiction: suppose that there is an edge $u - v$ which isn't
covered. If either $u$ or $v$ are tight, then $u - v$ is covered; thus the
constraints on both $u$ and $v$ are not tight. But this implies the algorithm
would continue (the edge $u - v$ cannot possibly be frozen).

\paragraph{The algorithm produces feasible solutions to $D_{wmvc}$.}
Each vertex cover $S$ is accompanied by a set of edge assignments
$y_{e} \in \mathbb{R^{+}}, \forall\; e \in E$. The assignments are $\geq 0$ as
they are initialized to zero and can only be increased. Additionally, the
algorithm only increases an assignment until it makes a neighboring vertex
tight; in other words, it maintains the desired invariant:
$\sum_{e\, \in\, inc(v)}\; y_{e} \leq w(v),\; \forall\; v \in V$. 


\paragraph{The algorithm is a 2-approximation.}
Let $S$ be a vertex cover produced by the algorithm, $y_e$ be the set of dual
variable assignments produced by the algorithm, and OPT the optimal solution to
WMVC. All vertices in $S$ are tight, and were tightened only by increments to $y_{e}$
variables as ``fuel''. By conservation of those increments, we have:

$$
\forall\; v \in S,\; w(v) = \sum_{e \in inc(v)} y_e  \Longrightarrow \sum_{v \in S} w(v) = \sum_{v \in S} \sum_{e \in inc(v)} y_e
$$

\noindent
The variables $y_e$ form a feasible solution to $D_{wmvc}$, so by the weak
duality theorem, their objective value is less than or equal to the optimal such solution,
$OPT_{D_{wmvc}}$. This optimum is (by the strong duality theorem) equal to $OPT_{L_{wmvc}}$,
 which is necessarily less than or equal to OPT. Chained together:

$$
\sum_{e \in E} y_e \leq OPT_{D_{wmvc}}  \leq OPT
$$

\noindent
Now we equate the following

$$
\sum_{v \in S} \sum_{e \in inc(v)} y_e \leq 2 * \sum_{e \in E} y_e
$$

\noindent
This holds because an edge may appear twice in the left hand side -- i.e,
suppose two tight vertices $u, v \in S$ have edge $u - v$. Then the value
$y_{e}$ will be summed twiced -- once for $u$ and once for $v$. In the worst
case, this occurs for every edge, which is the right hand side.  Putting
everything together:

$$
\sum_{v \in S} w(v) = \sum_{v \in S} \sum_{e \in inc(v)} y_e \leq 2 * \sum_{e \in E} y_e \leq 2 * OPT
$$

\noindent
meaning the algorithm is a 2-approximation.

\end{document}
